from direct.showbase.ShowBase import ShowBase
from panda3d.core import *

class ShaderTerrainDemo(ShowBase):
    def __init__(self):

        ShowBase.__init__(self)
        
        terrain_shader = Shader.load(Shader.SL_GLSL, "terrain.vert.glsl", "terrain.frag.glsl")

        self.terrain = self.loader.loadModel("plane")
        self.terrain.reparent_to(self.render)
        self.terrain.set_shader(terrain_shader)
        
        self.terrain.set_shader_input("resolution", (512.0, 512.0));

        taskMgr.add(self.update, "update")

    def update (self, task):

        self.terrain.set_shader_input("mouse", (base.mouseWatcherNode.getMouseY(), base.mouseWatcherNode.getMouseX()));
        self.terrain.set_shader_input("time", task.time);

        return task.cont

ShaderTerrainDemo().run()